﻿namespace MigrageAudienceHash
{
    public class Common
    {
        const int PartitionCount = 10;

        public static int GetHash(string macAddress)
        {
          return Math.Abs(GetDeterministicHashCode(macAddress) % PartitionCount);
        }
        static int GetDeterministicHashCode(string str)
        {
            unchecked
            {
                int hash1 = (5381 << 16) + 5381;
                int hash2 = hash1;

                for (int i = 0; i < str.Length; i += 2)
                {
                    hash1 = ((hash1 << 5) + hash1) ^ str[i];
                    if (i == str.Length - 1)
                        break;
                    hash2 = ((hash2 << 5) + hash2) ^ str[i + 1];
                }
                return Math.Abs(hash1 + (hash2 * 1566083941));
            }
        }
    }
}
