﻿using MigrageAudienceHash.DB.postgres;
using Npgsql;

namespace MigrageAudienceHash.Service
{
    public class AnalyticViewService
    {
        NpgsqlConnection _connection;
        const string DateSqlStartOfDayFormat = "yyyy-MM-dd";
        const string DateSqlEndOfDayFormat = "yyyy-MM-dd 23:59:59";

        string sqlRaw = "select place_id,campaign_id,page_code,string_agg(mac_address,',') audiencies " +
            "from analytic_view where created_date>'{0}' and created_date<'{1}' " +
            "group by place_id,campaign_id,page_code " +
            "order by place_id,campaign_id,page_code " +
            "offset {2} limit {3}";
        public AnalyticViewService(NpgsqlConnection connection)
        {
            _connection = connection;
        }

        public async Task<List<AnalyticView>> GetData(DateTime date, int pageIndex = 0, int pageSize = 100)
        {
            var results = new List<AnalyticView>();
            if (_connection.State == System.Data.ConnectionState.Closed)
                _connection.Open();

            var sql = string.Format(sqlRaw, date.ToString(DateSqlStartOfDayFormat), date.ToString(DateSqlEndOfDayFormat), pageSize * pageIndex, pageSize);
            using (var command = new NpgsqlCommand(sql, _connection))
            {
                var reader = await command.ExecuteReaderAsync();
                while (await reader.ReadAsync())
                {
                    results.Add(new AnalyticView
                    {
                        placeId = reader.GetInt64(0),
                        campaignId = reader.GetInt64(1),
                        pageCode = reader.GetString(2),
                        audiencies = reader.GetString(3)
                    });
                }

                _connection.Close();
            }
            return results;
        }

    }
}
