﻿using MigrageAudienceHash.DB.mongo;
using MongoDB.Driver;
using System.Linq.Expressions;

namespace MigrageAudienceHash.Service
{
    public class AudienceObjectService
    {
        private readonly MongoContext _context;

        public AudienceObjectService(MongoContext context)
        {
            _context = context;
        }

        public async Task<List<AudienceObject>> GetAudienceObjectByCondition(Expression<Func<AudienceObject, bool>> condition)
        {
            var results = new List<AudienceObject>();
            using (var cursor = await _context.AudienceObject.FindAsync(condition))
            {
                while (await cursor.MoveNextAsync())
                {
                    results.AddRange(cursor.Current);
                }
            }
            return results;
        }

        public async Task UpdateOrInsertOneAsync(AudienceObject audienceObject)
        {
            var update = Builders<AudienceObject>.Update.AddToSetEach(x => x.audiencies, audienceObject.audiencies);
            var item = await _context.AudienceObject.FindOneAndUpdateAsync(x =>
                                x.timeline == audienceObject.timeline &&
                                x.placeId == audienceObject.placeId &&
                                x.campaignId == audienceObject.campaignId &&
                                x.audienceHash == audienceObject.audienceHash &&
                                x.pageCode == audienceObject.pageCode, update);
            if (item == null)
            {
                await _context.AudienceObject.InsertOneAsync(audienceObject);
            }
        }
        public async Task InsertManyAsync(List<AudienceObject> audienceObjects)
        {
            await _context.AudienceObject.InsertManyAsync(audienceObjects);
        }
    }
}
